function [x]=forward_row(L,b)
[n]=mat_square(L);   
l = min(diag(abs(L))); 
if l == 0
  disp('Error: the matrix is singular'); x = [];
  break
end
x(1) = b(1)/L(1,1);
for i = 2:n, 
  x (i) = (b(i)-L(i,1:i-1)*(x(1:i-1))')/L(i,i); 
end
x=x';
return