function [x,k]=gmres(A,b,m,toll,x0)
r0=b-A*x0;  nr0=norm(r0,2);
if nr0 ~= 0
  v1=r0/nr0; 
  V=[v1]; 
  H=[]; 
  k=0; 
  residual=1;
  while k <= m-1 & residual > toll,     
    [k,V,H] = GSarnoldi(A,m,k,V,H); 
    [nr,nc]=size(H);    
    y=(H'*H) \ (H'*nr0*[1;zeros(nr-1,1)]);
    x=x0+V(:,1:nc)*y;   
    residual = norm(b-A*x,2)/nr0; 
  end
else
  x=x0;
end
return