function [T,iter]=qrshift(A,toll,itmax)
n=max(size(A)); 
iter=0; 
[T,Q]=houshess(A);
for k=n:-1:2
  I=eye(k); 
  while abs(T(k,k-1)) > toll*(abs(T(k,k))+abs(T(k-1,k-1)))
     iter=iter+1;  
     if (iter > itmax), 
        return
     end
     mu=T(k,k); 
     [Q,R,c,s]=qrgivens(T(1:k,1:k)-mu*I);
     T(1:k,1:k)=R*Q+mu*I;
  end
  T(k,k-1)=0; 
end
return