function [Ksg,rhsbc] = sgvisc(Nx, h, nu, beta)
Peclet=0.5*h*abs(beta)./nu; 
[bp, bn]=bern(2*Peclet);
Peclet=Peclet-1+bp;
for i=2:Nx,
   dd(i-1)=(nu(i-1)*Peclet(i-1)+nu(i)*Peclet(i))/h;
   if i > 2
     ld(i-2)=-nu(i-1)*Peclet(i-1)/h; 
   end
   if i < Nx
     ud(i-1)=-nu(i)*Peclet(i)/h;  
   end
end
Ksg=spdiags([[ld 0]',dd',[0 ud]'],-1:1,Nx-1,Nx-1);
rhsbc = - [nu(1)*Peclet(1)/h, nu(Nx)*Peclet(Nx)/h];
return