function [v,beta]=vhouse(x)
n=length(x); 
x=x/norm(x); 
s=x(2:n)'*x(2:n); 
v=[1; x(2:n)];
if (s==0), beta=0;
else
   mu=sqrt(x(1)^2+s);
   if (x(1) <= 0)
      v(1)=x(1)-mu;
   else
      v(1)=-s/(x(1)+mu);
   end
   beta=2*v(1)^2/(s+v(1)^2); 
   v=v/v(1);
end
return