function [k1] = cond_est(n,A,L,U,theta)
for i=1:n
   p(i)=0; 
end
for k=1:n
  zplus=(theta(k)-p(k))/U(k,k);
  zminu=(-theta(k)-p(k))/U(k,k);
  splus=abs(theta(k)-p(k));       
  sminu=abs(-theta(k)-p(k));
  for i=(k+1):n
     splus=splus+abs(p(i)+U(k,i)*zplus); 
     sminu=sminu+abs(p(i)+U(k,i)*zminu);
  end   
  if splus >= sminu
    z(k)=zplus;   
  else  
    z(k)=zminu;
  end
  for i=(k+1):n
     p(i)=p(i)+U(k,i)*z(k);  
  end
end
z = z'; 
x = backward_col(L',z); 
w = forward_col(L,x);   
y = backward_col(U,w);
k1=norm(A,1)*norm(y,1)/norm(x,1);
return