function [fftv]=fftrec(f,NN)
N = length(f);   w = exp(-2*pi*sqrt(-1)/N);
if N == 2
   fftv = f(1)+w.^[-NN/2:NN-1-NN/2]*f(2);
else
   a1 = f(1:2:N);   b1 = f(2:2:N);
   a2 = fftrec(a1,NN); b2 = fftrec(b1,NN);
   for k=-NN/2:NN-1-NN/2
      fftv(k+1+NN/2) = a2(k+1+NN/2) + b2(k+1+NN/2)*w^k;
   end   
end
