function [V,alpha,beta]=lanczos(A,m)
n=size(A); 
V=[0*[1:n]',[1,0*[1:n-1]]'];
beta(1)=0; 
normb=1; 
k=1;
while  k <= m & normb >= eps
  vk = V(:,k+1);        
  w = A*vk-beta(k)*V(:,k);
  alpha(k)= w'*vk;      
  w = w - alpha(k)*vk
  normb = norm(w,2);
  if normb ~= 0
    beta(k+1)=normb;    
    V=[V,w/normb];    
    k=k+1;
  end
end
[n,m]=size(V); 
V=V(:,2:m-1);
alpha=alpha(1:n); 
beta=beta(2:n);
return