function [L,U,P,Q] = LUpivtot(A,n)
P=eye(n); Q=P; Minv=P;
for k=1:n-1
  [Pk,Qk]=pivot(A,k,n);    
  A=Pk*A*Qk;
  [Mk,Mkinv]=MGauss(A,k,n);
  A=Mk*A;    
  P=Pk*P;  
  Q=Q*Qk;
  Minv=Minv*Pk*Mkinv;
end
U=triu(A);   
L=P*Minv;