function [D,sweep,psi]=cycjacobi(A,toll)
n=max(size(A)); 
D=A; 
psiD=norm(A,'fro'); 
epsi=toll*psiD; 
psiD=psinorm(D); 
[psi]=psiD; 
sweep=0; 
while (psiD > epsi) 
  sweep=sweep+1;
  for p=1:(n-1)
    for q=(p+1):n
       [c,s]=symschur(D,p,q); 
       [D]=gacol(D,c,s,1,n,p,q);
       [D]=garow(D,c,s,p,q,1,n);
    end; 
  end; 
  psiD=psinorm(D); 
  psi=[psi; psiD];
end
return